#!/usr/bin/env python
# -*- coding: utf-8 -*-

import requests, sys, os, json
from datetime import date

datarrayse = lambda d: [int(a) for a in d.split("-")]
datize = lambda d: date(*datarrayse(d))

if not os.path.exists(".cache"):
    os.makedirs(".cache")
def download(parl):
    filename = os.path.join(".cache", "%s.html" % parl.replace(' ', '-'))
    if os.path.exists(filename):
        with open(filename, 'r') as f:
            return json.load(f)
    try:
        meta = requests.get("http://www.nossenateurs.fr/%s/json" % parl).json()[u'senateur']
    except:
        try:
            meta = requests.get("http://www.nosdeputes.fr/%s/json" % parl).json()[u'depute']
        except:
            print >> sys.stderr, "WARNING Could not find %s" % parl
            return None
    with open(filename, 'w') as f:
        json.dump(meta, f)
    return meta

with open("declarations-dinterets-parlementaires_1.0/13_dates_reception.csv", 'r') as f:
    data = f.read()

histogram = [0] * 300
histogram30 = [0] * 10
csvfile = open("delais_depot.csv", 'w')
print >> csvfile, "parlementaire,différence dépôt/deadline en jours"
for d in data.split('\n')[1:]:
    if not d: continue
    try:
        (parl, depot) = d.split(";")
    except:
        print >> sys.stderr, "WARNING bad line in data : %s" % d
        continue

    try:
        depot = datize(depot)
    except:
        print >> sys.stderr, "WARNING bad date for %s: %s" % (parl, depot)
        print >> csvfile, "%s,inconnu" % parl
        histogram[0] += 1
        histogram30[0] += 1
        continue

    meta = download(parl)
    if not meta:
        continue

    deadline = "2014-02-01"
    if meta[u"mandat_debut"] > "2013-12-01":
        (annee, mois, jour) = datarrayse(meta[u"mandat_debut"])
        mois += 2
        if mois > 12:
            mois -= 12
            annee += 1
        deadline = "%04d-%02d-%02d" % (annee, mois, jour)
    deadline = datize(deadline)

    delay = (depot - deadline).days
    print >> csvfile, "%s,%s" % (parl, delay)
    histogram[delay+100] += 1
    histogram30[(delay+90)/30+1] += 1

csvfile.close()

with open("histogram_delais.csv", "w") as f:
    print >> f, "délai dépôt (jours),nombre de parlementaires"
    for i, v in enumerate(histogram):
        print >> f, "%s,%s" % (i-100, v)

with open("histogram_delais_mois.csv", "w") as f:
    print >> f, "délai dépôt (moins de x jours),nombre de parlementaires"
    for i, v in enumerate(histogram30):
        print >> f, "%s,%s" % (30*i-90, v)
